SystemOrganization addCategory: #'Pier-Environment'!

PRCommand subclass: #PRChangeEnvironment
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Environment'!

!PRChangeEnvironment class methodsFor: 'accessing-environments' stamp: 'lr 6/10/2006 10:16'!
both
	^ (PRPage named: 'environment')
		addChild: ((PRComponent named: 'header')
			componentClass: PRHeaderWidget;
			yourself);
		addChild: ((PRComponent named: 'views')
			componentClass: PRViewsWidget;
			yourself);
		addChild: ((PRComponent named: 'commands')
			componentClass: PRCommandsWidget;
			yourself);
		addChild: ((PRComponent named: 'tree')
			componentClass: PRTreeWidget;
			yourself);
		addChild: ((PRComponent named: 'toc')
			componentClass: PRTocWidget;
			yourself);
		addChild: ((PRComponent named: 'references')
			componentClass: PRReferencesWidget;
			yourself);
		addChild: ((PRComponent named: 'search')
			componentClass: PRSearchWidget;
			yourself);
		addChild: ((PRComponent named: 'main')
			componentClass: PRContentsWidget;
			yourself);
		contents: '+header+
<table class="body"><tr><td class="boxes">+views+<br />+commands+<br />+tree+</td><td class="spacer"></td><td class="main">+main+</td><td class="spacer"></td><td class="boxes">+toc+<br />+references+<br />+search+</tr></table>';
		yourself! !

!PRChangeEnvironment class methodsFor: 'accessing-descriptions' stamp: 'lr 6/10/2006 10:18'!
descriptionEnvironment
	^ (MASingleOptionDescription selector: #environment label: 'Template' priority: 100)
		options: (MADynamicObject on: [ self environments ]);
		undefined: '(inherit)';
		yourself! !

!PRChangeEnvironment class methodsFor: 'accessing' stamp: 'lr 6/10/2006 10:25'!
environments
	^ Array streamContents: [ :stream |
		self class organization categories do: [ :each |
			(each endsWith: #environments) ifTrue: [ 
				stream nextPutAll: (self class organization
					listAtCategoryNamed: each) ] ] ]! !

!PRChangeEnvironment class methodsFor: 'testing' stamp: 'lr 6/10/2006 09:57'!
isAbstract
	^ false! !

!PRChangeEnvironment class methodsFor: 'accessing' stamp: 'lr 6/10/2006 09:57'!
label
	^ 'Environment'! !

!PRChangeEnvironment class methodsFor: 'accessing-environments' stamp: 'lr 6/10/2006 10:12'!
left
	^ (PRPage named: 'environment')
		addChild: ((PRComponent named: 'header')
			componentClass: PRHeaderWidget;
			yourself);
		addChild: ((PRComponent named: 'views')
			componentClass: PRViewsWidget;
			yourself);
		addChild: ((PRComponent named: 'commands')
			componentClass: PRCommandsWidget;
			yourself);
		addChild: ((PRComponent named: 'tree')
			componentClass: PRTreeWidget;
			yourself);
		addChild: ((PRComponent named: 'main')
			componentClass: PRContentsWidget;
			yourself);
		contents: '+header+
<table class="body"><tr><td class="boxes">+views+<br />+commands+<br />+tree+</td><td class="spacer"></td><td class="main">+main+</td></tr></table>';
		yourself! !

!PRChangeEnvironment class methodsFor: 'accessing-environments' stamp: 'lr 6/10/2006 10:13'!
right
	^ (PRPage named: 'environment')
		addChild: ((PRComponent named: 'header')
			componentClass: PRHeaderWidget;
			yourself);
		addChild: ((PRComponent named: 'views')
			componentClass: PRViewsWidget;
			yourself);
		addChild: ((PRComponent named: 'commands')
			componentClass: PRCommandsWidget;
			yourself);
		addChild: ((PRComponent named: 'tree')
			componentClass: PRTreeWidget;
			yourself);
		addChild: ((PRComponent named: 'main')
			componentClass: PRContentsWidget;
			yourself);
		contents: '+header+
<table class="body"><tr><td class="main">+main+</td><td class="spacer"></td><td class="boxes">+views+<br />+commands+<br />+tree+</td></tr></table>';
		yourself! !

!PRChangeEnvironment methodsFor: 'events' stamp: 'lr 6/10/2006 10:26'!
doExecute
	| children |
	children := self structure childrenDecoration.
	children
		at: self structure environmentSelector
		ifPresent: [ :each | children remove: each ].
	self environment ifNil: [ ^ self ].
	children add: ((self class perform: self environment)
		addDecoration: PRHider new;
		yourself)! !

!PRChangeEnvironment methodsFor: 'accessing' stamp: 'lr 6/10/2006 09:55'!
environment
	^ environment! !

!PRChangeEnvironment methodsFor: 'accessing' stamp: 'lr 6/10/2006 10:01'!
environment: aSymbol
	environment := aSymbol! !
